"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.registerModel = exports.query = exports.start = exports.init = void 0;

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _hooks = require("@forrestjs/hooks");

var hooks = _interopRequireWildcard(require("./hooks"));

var _init = _interopRequireDefault(require("./init"));

exports.init = _init.default;

var _start = _interopRequireDefault(require("./start"));

exports.start = _start.default;

var _conn = require("./conn");

exports.getHandler = _conn.getHandler;
exports.getModel = _conn.getModel;
exports.resetModels = _conn.resetModels;
exports.registerModel = _conn.registerModel;

var _query = _interopRequireDefault(require("./query"));

exports.query = _query.default;

var _default = ({
  registerHook,
  registerAction,
  createHook
}) => {
  registerHook(hooks);
  registerAction({
    hook: _hooks.INIT_SERVICE,
    name: hooks.SERVICE_NAME,
    trace: __filename,
    handler: function () {
      var _handler = (0, _asyncToGenerator2.default)(function* ({
        getConfig,
        setContext,
        getContext
      }, ctx) {
        const connections = getConfig('postgres.connections'); // Let features hook into the existing connections configuration

        createHook.sync(hooks.POSTGRES_BEFORE_INIT, {
          connections
        });

        for (var _iterator = connections, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          const options = _ref;

          // #18 apply defaults to the models list
          if (!options.models) {
            options.models = [];
          }

          const connName = options.connectionName || 'default';
          createHook.sync(`${hooks.POSTGRES_BEFORE_INIT}/${connName}`, {
            options
          });
          yield (0, _init.default)(options, ctx);
          createHook.sync(`${hooks.POSTGRES_AFTER_INIT}/${connName}`, {
            options
          });
        } // Decorate the context with the PG context


        setContext('pg', {
          query: _query.default,
          getModel: _conn.getModel,
          getHandler: _conn.getHandler,
          resetModels: _conn.resetModels
        });
        createHook.sync(hooks.POSTGRES_AFTER_INIT, Object.assign({}, getContext('pg'), {
          connections
        }));
      });

      function handler(_x, _x2) {
        return _handler.apply(this, arguments);
      }

      return handler;
    }()
  });
  registerAction({
    hook: _hooks.START_SERVICE,
    name: hooks.SERVICE_NAME,
    trace: __filename,
    handler: function () {
      var _handler2 = (0, _asyncToGenerator2.default)(function* ({
        getConfig,
        getContext
      }, ctx) {
        const connections = getConfig('postgres.connections');
        yield createHook.serie(hooks.POSTGRES_BEFORE_START, Object.assign({}, getContext('pg'), {
          connections
        }));

        for (var _iterator2 = connections, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref2 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref2 = _i2.value;
          }

          const options = _ref2;
          const connName = options.connectionName || 'default';
          createHook.serie(`${hooks.POSTGRES_BEFORE_START}/${connName}`, Object.assign({}, getContext('pg'), {
            registerModel: model => options.models.push(model)
          }));
          yield (0, _start.default)(options, ctx);
          createHook.serie(`${hooks.POSTGRES_AFTER_START}/${connName}`, Object.assign({}, getContext('pg'), {
            handler: (0, _conn.getHandler)(connName)
          }));
        }

        yield createHook.serie(hooks.POSTGRES_AFTER_START, Object.assign({}, getContext('pg'), {
          connections
        }));
      });

      function handler(_x3, _x4) {
        return _handler2.apply(this, arguments);
      }

      return handler;
    }()
  });
};

exports.default = _default;